@use "colors";
@use "core";

$offset: 6px;
$offset-hover: 3px;
$offset-move: $offset - $offset-hover;

@mixin activeState() {
    transform: translate(-$offset, $offset);
    transition: transform 150ms ease-out, box-shadow 150ms ease-out, border 100ms ease-in;
    box-shadow: 0 0 0 0 colors.$content-white, 0 0 colors.$content-black;
    border: 1px solid colors.$content-black;
}

@mixin keyboardFocus() {
    @include activeState();
    outline: none;
    box-shadow: 0px 0px 10px colors.$turquoise;
}

@mixin secondary {
    color: colors.$content-black;
    background-color: transparent;
    border: 1px solid colors.$content-black;

    a {
        color: colors.$content-black;
    }
}

@mixin button {
    display: block;
    cursor: pointer;
    font-family: Graph;
    font-weight: bold;
    font-size: 1.25rem;
    padding: 0.4em 1.3em;
    letter-spacing: 0.04em;

    margin-left: 5px;
    margin-bottom: 5px;

    border-radius: 3px;
    line-height: normal;
    @include core.fit-content-width();
    @include core.fit-content-height();

    box-shadow: -$offset $offset 0 -1px colors.$content-white, -$offset $offset colors.$content-black;
    transition: transform 100ms ease-out, box-shadow 100ms ease-out;


    &:hover {
        transform: translate(-$offset-move, $offset-move);
        transition: transform 200ms ease-out, box-shadow 200ms ease-out;
        box-shadow: -$offset-hover $offset-hover 0 -1px colors.$content-white, -$offset-hover $offset-hover colors.$content-black;
        text-decoration: none !important;
    }

    &:active {
        @include activeState();
    }

    &.primary {
        color: colors.$content-background;
        background-color: colors.$content-black;
        border: 1px solid colors.$content-white;

        a {
            color: colors.$content-background;
        }
    }

    &.secondary {
        @include secondary;
    }

    // Focus wird hier leider (für Accesability schlecht) zurückgesetzt,
    // da in vielen Browsern sonst der focus State auch beim Klicken erscheint (und nicht nur bei Tastatur)
    &:focus {
        outline: none;
    }

    // für Accesability
    // besser als focus da nur durch Tastatur ausgelöst
    // momentan von den meisten Browsern noch nicht supported, kommt aber in Zukunft
    &:focus-visible {
        @include keyboardFocus();
    }

    &:-moz-focusring {
        @include keyboardFocus();
    }

    &::-moz-focus-inner {
        border: 0;
    }

    .expand-collapse-icon {
        padding-left: 0.6rem;

        svg {
            vertical-align: top;
        }
    }
}

.button {
    @include button;
}

.scroll-to-top {
    position: fixed !important;
    padding-left: 0.5rem;
    padding-right: 0.5rem;
    bottom: 20px;
    right: 50px;
    border-radius: 2rem;
    display: flex;
    z-index: 1;
    background-color: colors.$content-black !important;
    border: 1px colors.$gray solid;
    color: colors.$content-white !important;
}